checkRequire("Lua_RedEnvelopeDetailItem")
Lua_GrabRedEnvelopeWindow = class("Lua_GrabRedEnvelopeWindow", Lua_Window);
function Lua_GrabRedEnvelopeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GrabRedEnvelopeWindow";
	self.skinName = "GrabRedEnvelopeWindow_skin";
	self.layer = 4500;
	self.isClickClose = true;
end

function Lua_GrabRedEnvelopeWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("UPDATA_RED_ENVELOPE_DETAIL_PANEL", self, self.updatePanel);
end

function Lua_GrabRedEnvelopeWindow:showWin(param)
	self:superCall("showWin", param);

	if isHeadReplaceOpen() == true then
		self:updataCustomHead();
	else
		self.portrait:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(DataCenter.roleData.career));
	end
	self.nameTxt.text = DataCenter.roleData.name;
	self.totalAmountObj:SetActive(false);

	Lua_ProxyManager.getProxy("Lua_RedEnvelopeProxy"):sRedEnvelopeDetail({type = 2, id = param.itemVo.id});
end

function Lua_GrabRedEnvelopeWindow:updataCustomHead()
    local role_head = DataCenter.roleData.getDressHead;
    if role_head ~= nil and role_head ~= "" then
    	local isDefault = DataCenter.roleData:isDefaultHead(DataCenter.roleData.career, role_head);
        if isDefault == true then
            self.portrait:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
        else
            self.portrait:setUrl(role_head, 99, true);
	    	-- self.portrait:setRoundSize(1, 0.5, 0.5, 0.5); -- 菱形
	    	self.portrait:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
	    	self.portrait:SetDimensions(75, 75);
        end
    end
end

function Lua_GrabRedEnvelopeWindow:updatePanel(serverData)
	self.serverData = serverData;

	local detailVo = serverData.detailVo;
	self.totalAmountObj:SetActive(true);
	self.totalAmountTxt.text = detailVo.selfAmount;

	local moneyId = self.showData.itemVo.moneyId;
	self.moneyVo = Lua_ToolVo.new(moneyId);
	self.desLabel.text = LanUtil.formateStr(
		LanUtil.getValue(124304),
		tostring(detailVo.receiveNumber),
		tostring(detailVo.number),
		tostring(detailVo.amount),
		DataCenter.moneyData:getNameByType(moneyId)
	);

	local atlas = Lua_MoneyData.getMoneyIconAtlas(moneyId);
	local spriteName = Lua_MoneyData.getIconSpByMoneyType(moneyId);
	self.moneyImg:setAltas(atlas, spriteName);

	self:updateItemListPanel();
end

function Lua_GrabRedEnvelopeWindow:updateItemListPanel()
	local arr = self.serverData.detailVo.receiveRecordList;
	for i = 1, arr:getSize() do
		arr[i].flag = self.showData.itemVo.flag;
		arr[i].moneyVo = self.moneyVo;
	end

	if self.dragList == nil then
		self.dragList = Lua_DragList.new(self.content,1, Vector4(17, -40, 276, 146));
		self.dragList:setListCell(Lua_RedEnvelopeDetailItem, 63, 326, 1);
		self.dragList:setLocation(1, -77.5, 0);
	end
	self.dragList:setLuaArrayData(arr, false);
end