Lua_RedEnvelopeDetailItem = class("Lua_RedEnvelopeDetailItem", Lua_ListCell);
function Lua_RedEnvelopeDetailItem:ctor(p)
	self:superCall("ctor", p, "RedEnvelopeDetailItem_skin");
end

function Lua_RedEnvelopeDetailItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_RedEnvelopeDetailItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = data.name;
	self.amount.text = data.amount;

	if isHeadReplaceOpen() == true then
		self:updataCustomHead();
	else
		self.portrait:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(data.career));
		self.portrait:SetDimensions(50, 46);
		self.portrait:setLocation(-118, 2.5, 0);
	end

	-- if data.isMax == true and data.flag == 2 then
	-- 	local amountPos = self.amount.widget.transform.localPosition;
	-- 	self.label:setLocation(amountPos.x-self.amount.width-11,amountPos.y,amountPos.z);
	-- 	self.label:setEnable(true);
	-- else
	-- 	self.label:setEnable(false);
	-- end

	local moneyId = data.moneyVo.id;
	local atlas = Lua_MoneyData.getMoneyIconAtlas(moneyId);
	local spriteName = Lua_MoneyData.getIconSpByMoneyType(moneyId);
	self.moneyImg:setAltas(atlas, spriteName);
end

function Lua_RedEnvelopeDetailItem:updataCustomHead()
	local role_head = self.data.head_name;
	if role_head ~= nil and role_head ~= "" then
		local isDefault = DataCenter.roleData:isDefaultHead(self.data.career, role_head);
		if isDefault == true then
			self.portrait:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
			self.portrait:SetDimensions(49, 49);
		else
			self.portrait:setUrl(role_head, 99, true);
			-- self.portrait:setRoundSize(1, 0.5,0.5,0.5); -- 菱形
			self.portrait:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
			self.portrait:SetDimensions(49, 49);
		end
	end
end