Lua_RedEnvelopeInput = class("Lua_RedEnvelopeInput", Lua_DisplayObject);
function Lua_RedEnvelopeInput:ctor(param)
	self.param = param;
	self:superCall("ctor", param.p, "RedEnvelopeInput_skin");
end

function Lua_RedEnvelopeInput:buildShowItem()
	self:superCall("buildShowItem");

	if self.param.num.value >= self.param.num.min and self.param.num.value <= self.param.num.max then
		self.num = self.param.num.value;
	elseif self.param.num.value < self.param.num.min then
		self.num = self.param.num.min;
	elseif self.param.num.value > self.param.num.max then
		self.num = self.param.num.max;
	end

	self.numTxt:addClickFuntion(self, self.onNumTxtClick);
	self.numMinusBtn:addClickFuntion(self, self.onMinusBtn);
	self.numPlusBtn:addClickFuntion(self, self.onPlusBtn);
end

function Lua_RedEnvelopeInput.Get:num()
	return self._num;
end

function Lua_RedEnvelopeInput.Set:num(value)
	self._num = value;

	if self._num < self.param.num.min then
		self._num = self.param.num.min
		if self.param.num.showErrorMin ~= nil then
			OperateAlert.show(self.param.num.showErrorMin);
		end
	elseif self._num > self.param.num.max then
		self._num = self.param.num.max
		if self.param.num.showErrorMax ~= nil then
			OperateAlert.show(self.param.num.showErrorMax);
		end
	end
	self.param.num.value = self.num;
	self.numTxt.text = self.num;

	if self.param.owner ~= nil and self.param.onCallBackFun ~= nil then
		self.param.onCallBackFun(self.param.owner);
	end
end

function Lua_RedEnvelopeInput.Get:tempNum()
	return self._tempNum;
end

function Lua_RedEnvelopeInput.Set:tempNum(value)
	self._tempNum = value;
	self.numTxt.text = value;
end

function Lua_RedEnvelopeInput:onMinusBtn()
	self.num = self.num - 1;
end

function Lua_RedEnvelopeInput:onPlusBtn()
	self.num = self.num + 1;
end

function Lua_RedEnvelopeInput:onNumTxtClick()
	self.isFirstClick = true;
	self.tempNum = self.num;
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, {
		pox = 333,
		poy = -18,
		callBackOwner = self,
		callBack = self.onInputClick
	});
end

function Lua_RedEnvelopeInput:onInputClick(data)
	if data == nil then
		return;
	end

	if data.state == 0 then -- 重置
		self.tempNum = self.param.num.min;
		self.isFirstClick = true;
	elseif data.state == 1 then -- 数字
		if self.isFirstClick == true then
			self.tempNum = data.num;
		else
			local str = self.tempNum > 0 and self.tempNum..data.num or tostring(data.num);
			local len = string.len(str);
			local maxLen = 3;
			if len > maxLen then
				str = string.sub(str, len - maxLen + 1, len);
			end 
			self.tempNum = tonumber(str);
		end
		self.isFirstClick = false;
	elseif data.state == 2 then -- ok
		self.num = self.tempNum;
	end
end