checkRequire("Lua_RedEnvelopeInput")
Lua_SendRedEnvelopeWindow = class("Lua_SendRedEnvelopeWindow", Lua_Window);
function Lua_SendRedEnvelopeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SendRedEnvelopeWindow";
	self.skinName = "SendRedEnvelopeWindow_skin";
	self.showBg = false;
	self.layer = 3500;
end

function Lua_SendRedEnvelopeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.totalAmount = 0;

	local redEnvelopeData = DataCenter.redEnvelopeData;
	local redEnvelopeConfig = redEnvelopeData.redEnvelopeConfig;
	local leagueCount = DataCenter.factionData.myFactionInfo.leagueCount;
	local minNum = redEnvelopeConfig["player_send_red_packet_min_count"]["value"];
	self.envelopeNum = {};
	self.envelopeNum.value = minNum;
	self.envelopeNum.min = leagueCount < 10 and leagueCount or minNum;
	self.envelopeNum.max = leagueCount;
	self.envelopeNum.showErrorMin =  LanUtil.formateStr(LanUtil.getValue(124309), tostring(self.envelopeNum.min));
	self.envelopeNum.showErrorMax = LanUtil.getValue(124308);

	local minAmount = redEnvelopeConfig["player_red_packet_money"]["arr"];
	self.envelopeAmount = {};
	self.envelopeAmount.value = minAmount[1];
	self.envelopeAmount.min = minAmount[1];
	self.envelopeAmount.max = minAmount[2];
	self.envelopeAmount.showErrorMin = LanUtil.formateStr(LanUtil.getValue(124311), tostring(self.envelopeAmount.min));
	self.envelopeAmount.showErrorMax = LanUtil.formateStr(LanUtil.getValue(124310), tostring(self.envelopeAmount.max));
	
	self.sendBtn:addClickFuntion(self, self.onSendBtn);
	
	self:addLuaEvent("UPDATA_RED_ENVELOPE_DETAIL_PANEL", self, self.updatePanel);
	DataCenter.factionData:sFactionList();
end

function Lua_SendRedEnvelopeWindow:showWin(param)
	self:superCall("showWin", param);
	-- winType 1答题获得的红包或其他 2VIP发送红包

	if param.winType == 1 then
		Lua_ProxyManager.getProxy("Lua_RedEnvelopeProxy"):sRedEnvelopeDetail({type = 2, id = param.itemVo.id});
		
		self.moneyVo = Lua_ToolVo.new(param.itemVo.moneyId);

		self.numInput = Lua_RedEnvelopeInput.new({p = self.content, num = self.envelopeNum});
		self.numInput:setLocation(66.5, 93, 0);

		self.desLab1:setLocation(-62, 138);
		self.desLab2:setLocation(-62, 93);

		LuaUtil.setObjPos(self.totalAmountObj1, 19, 4, 0);
		self.totalAmountTxt1.fontSize = 24;
		self.totalAmountTxt1.colorStr = Lua_ColorDefine.transColor("00E125");
		self.totalAmountTxt1.spacingX = 1;

		self.showObj:SetActive(false);
		self.singleAmountTxt:setEnable(true);
	else
		local redEnvelopeConfig = DataCenter.redEnvelopeData.redEnvelopeConfig;
		local itemId = redEnvelopeConfig["player_send_red_packet_money_type"]["value"];
		self.moneyVo = Lua_ToolVo.new(itemId);

		itemId = redEnvelopeConfig["player_send_red_packet_cost_money_type"]["value"];
		self.costMoneyVo = Lua_ToolVo.new(itemId);
		self.moneyImg2:setAltas("icon_atlas_3", "money_"..self.costMoneyVo.id);

		self.numInput = Lua_RedEnvelopeInput.new({p = self.content, num = self.envelopeNum});
		self.numInput:setLocation(66.5, 115.5, 0);

		self.amountInput = Lua_RedEnvelopeInput.new({p = self.content, num = self.envelopeAmount, owner = self, onCallBackFun = self.updateMoneyCount});
		self.amountInput:setLocation(66.5, 157.5, 0);
		
		self.textInput.text = LanUtil.getValue(124306);
		self.textInput.defaultText = LanUtil.getValue(124306);
		self.textInput.characterLimit = 12;

		LuaUtil.setObjPos(self.totalAmountObj1, 70, 14, 0);

		self.singleAmountTxt:setEnable(false);
		self.showObj:SetActive(true);
	end
	local moneyName = DataCenter.moneyData:getNameByType(self.moneyVo.id);
	self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(124312), moneyName);
	self.moneyImg1:setAltas("icon_atlas_3", "money_"..self.moneyVo.id);
end

function Lua_SendRedEnvelopeWindow:updatePanel(data)
	self.serverData = data;
	if self.showData.winType == 1 then
		self.singleAmountTxt.text = LanUtil.formateStr(LanUtil.getValue(124303), tostring(data.detailVo.amount), tostring(self.moneyVo.name));
		self:setTotalAmount(data.detailVo.amount);
	end
end

function Lua_SendRedEnvelopeWindow:updateMoneyCount()
	self:setTotalAmount(self.envelopeAmount.value);
end

function Lua_SendRedEnvelopeWindow:setTotalAmount(value)
	self.totalAmount = value;
	if self.showData.winType == 1 then
		self.totalAmountTxt1.text = value;
	else
		self.totalAmountTxt1.text = value;
		self.totalAmountTxt2.text = value;
	end
end

function Lua_SendRedEnvelopeWindow:onSendBtn()
	if (self.showData.winType == 2 and LanUtil.isIncludeInvalidWord(self.textInput.text)) == true then
		OperateAlert.show(LanUtil.getValue(124316));
		return;
	end

	if self.totalAmount < self.envelopeNum.value then
		OperateAlert.show(LanUtil.getValue(124313));
		return;
	end

	self.sendParam = {};
	self.sendParam.type = self.showData.type;
	self.sendParam.amount = self.totalAmount;
	self.sendParam.number = self.envelopeNum.value;
	self.sendParam.msg = "";
	self.sendParam.redId = 0;
	if self.showData.winType == 1 then
		self.sendParam.redId = self.showData.itemVo.id;
		self:sendEnvelope();
	else
		self.sendParam.msg = self.textInput.text;
		self:sendEnvelope();

		local gold = DataCenter.moneyData:getMoney(self.costMoneyVo.id);
		if gold < self.totalAmount then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
				owner = self,
				des = LanUtil.getValue(124317),
				type = 1,
				subFun = self.openChargeWin
			});
		end
	end
	self:hide();
end

function Lua_SendRedEnvelopeWindow:sendEnvelope()
	Lua_ProxyManager.getProxy("Lua_RedEnvelopeProxy"):sSendRedEnvelope(self.sendParam);
end

function Lua_SendRedEnvelopeWindow:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN);
end