Lua_FactionRedEnvelopeItem = class("Lua_FactionRedEnvelopeItem", Lua_ListCell);
function Lua_FactionRedEnvelopeItem:ctor(p)
	self:superCall("ctor", p, "FactionRedEnvelopeItem_skin");
end

function Lua_FactionRedEnvelopeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btn1:SetActive(false);
	self.btn2:SetActive(false);
	self.btn3:SetActive(false);
	self.stateTxt:setEnable(false);
	self.tipsLab:setEnable(false);

	self.btn1Effect = UICreate.createUIEffect(self.btn1,  "/effects/scsEffects/gui_fahongbao", "gui_fahongbao", 0, 0);
	self.btn1Effect:SetRenderQueue(self.btnBg1, 1, 2,false);

	self.btn3Effect = UICreate.createUIEffect(self.btn3,  "/effects/scsEffects/gui_fahongbao", "gui_fahongbao", 0, 0);
	self.btn3Effect:SetRenderQueue(self.btnBg3, 1, 2,false);

	self.btnBg1:addClickFuntion(self, self.onBtnClick1);
	self.btnBg2:addClickFuntion(self, self.onBtnClick2);
	self.btnBg3:addClickFuntion(self, self.onBtnClick3);
	self.tipsLab:addClickFuntion(self, self.onShowOtherInfoClick);

	Lua_CommonUtil.addTimer("EFFECT_POS_DETECTION", 0.02, self, self.effectPosDetection);
end

function Lua_FactionRedEnvelopeItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = data.name;
	self.msgTxt.text = data.msg;

	if isHeadReplaceOpen() == true then
		self:updataCustomHead();
	else
		self.portrait:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(data.career));
	end
	self:setRedEnvelopeState(data.flag);
end

function Lua_FactionRedEnvelopeItem:updataCustomHead()
	local role_head = self.data.role_head_name;
	if role_head ~= nil and role_head ~= "" then
		local isDefault = DataCenter.roleData:isDefaultHead(self.data.career, role_head);
		if isDefault == true then
			self.portrait:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
		else
			self.portrait:setUrl(role_head, 99, true);
			-- self.portrait:setRoundSize(1, 0.5, 0.5, 0.5); -- 菱形
			self.portrait:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
		end
	end
end

function Lua_FactionRedEnvelopeItem:effectPosDetection()
	if self.btn1.activeInHierarchy == true then
		if self.btn1Effect.mainContent.transform.position.y > 0.54
			or self.btn1Effect.mainContent.transform.position.y < -0.54 then
			self.btn1Effect:setEnable(false);
		else
			self.btn1Effect:setEnable(true);
		end
	end

	if self.btn3.activeInHierarchy == true then
		if self.btn3Effect.mainContent.transform.position.y > 0.54
			or self.btn3Effect.mainContent.transform.position.y < -0.54 then
			self.btn3Effect:setEnable(false);
		else
			self.btn3Effect:setEnable(true);
		end
	end
end

function Lua_FactionRedEnvelopeItem:setRedEnvelopeState(flag)
	if flag == 0 then
		self.btn1:SetActive(true);
		self.btn2:SetActive(false);
		self.btn3:SetActive(false);
		self.stateTxt:setEnable(false);
		self.tipsLab:setEnable(false);
	elseif flag == 1 then
		self.btn1:SetActive(false);
		self.btn2:SetActive(false);
		self.btn3:SetActive(false);
		self.stateTxt:setEnable(true);
		self.stateTxt.text = LanUtil.getValue(124301);
		self.tipsLab:setEnable(true);
	elseif flag == 2 then
		self.btn1:SetActive(false);
		self.btn2:SetActive(false);
		self.btn3:SetActive(false);
		self.stateTxt:setEnable(true);
		self.stateTxt.text = LanUtil.getValue(124302);
		self.tipsLab:setEnable(true);
	elseif flag == 3 then
		self.btn1:SetActive(false);
		self.btn2:SetActive(self.data.name ~= DataCenter.roleData.name);
		self.btn3:SetActive(self.data.name == DataCenter.roleData.name);
		self.stateTxt:setEnable(false);
		self.tipsLab:setEnable(false);
	end
end

function Lua_FactionRedEnvelopeItem:onBtnClick1()
	Lua_ProxyManager.getProxy("Lua_RedEnvelopeProxy"):sGrabRedEnvelope({type = 2, id = self.data.id});
	Lua_WindowUtil.openWin("Lua_GrabRedEnvelopeWindow", nil, {itemVo = self.data});
end

function Lua_FactionRedEnvelopeItem:onBtnClick2()
	OperateAlert.show(LanUtil.getValue(124305));
end

function Lua_FactionRedEnvelopeItem:onBtnClick3()
	Lua_WindowUtil.openWin("Lua_SendRedEnvelopeWindow", nil, {winType = 1,type = 2, itemVo = self.data});
end

function Lua_FactionRedEnvelopeItem:onShowOtherInfoClick()
	Lua_WindowUtil.openWin("Lua_GrabRedEnvelopeWindow", nil, {itemVo = self.data});
end

function Lua_FactionRedEnvelopeItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.effectPosDetection);
	self:superCall("dispose");
end