Lua_FactionRedEnvelopeLeftPanel = class("Lua_FactionRedEnvelopeLeftPanel", Lua_DragContainerItem);
function Lua_FactionRedEnvelopeLeftPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FactionRedEnvelopeLeftPanel:buildShowItem()
	self.height = 220;
end

function Lua_FactionRedEnvelopeLeftPanel:setData(data)
	self.data = data;

	if self.itemList ~= nil then
		for i = 1, self.itemList:getSize() do
			self.itemList[i].infoTxt:dispose();
			self.itemList[i].infoTxt = nil;
			self.itemList[i].timeTxt:dispose();
			self.itemList[i].timeTxt = nil;
		end
		self.itemList:clear();
		self.itemList = nil;
	end
	self.itemList = Array();

	local infoList = data.brocastInfoList;
	local lastIndex = 0;
	for i = 1, infoList:getSize() do
		local timeTxt = UICreate.createLabel(self.content, "", -2, 55, 428, 22, 22);
		timeTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		timeTxt.pivot = UIWidget.Pivot.TopLeft;

		local infoTxt = UICreate.createLabel(self.content, "", -2, 55, 440, 22, 22);
		infoTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
		infoTxt.pivot = UIWidget.Pivot.TopLeft;

		if lastIndex == 0 then
			timeTxt:setLocation(-220, 206);
			infoTxt:setLocation(-220, 206);
		else
			local widget = self.itemList[lastIndex].infoTxt.widget;
			timeTxt:setLocation(-220,widget.transform.localPosition.y - widget.height - 10);
			
			local line = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_x_02",0,0,0,0)
			line:setLocation(10.2,widget.transform.localPosition.y - widget.height - 10);
			infoTxt:setLocation(-220,widget.transform.localPosition.y - widget.height - 20);
		end

		local tempStr = infoList[i].time;
		local timeList = string.split(os.date("%Y_%m_%d_%H_%M_%S",tempStr),"_");
		local str = LanUtil.formateStr("[85A8BE][{1}-{2}"..Lua_ChatUtil.FACE_SPACE.."{3}:{4}]",tostring(timeList[2]),tostring(timeList[3]),tostring(timeList[4]),tostring(timeList[5]));
		timeTxt.text = "";
		infoTxt.text = "/t"..infoList[i].shoutStr;
		infoTxt.text = str..infoList[i].shoutStr;
		infoTxt.spacingY = 4
		
		lastIndex = i;
		self.itemList:add({infoTxt = infoTxt, timeTxt = timeTxt, line = line});
	end

	if self.itemList:getSize() >= 1 then
		self.height = self.itemList[1].infoTxt.widget.transform.localPosition.y - self.itemList[lastIndex].infoTxt.widget.transform.localPosition.y + self.itemList[lastIndex].infoTxt.height + 10;
	else
		self.height = 0;
	end
end

function Lua_FactionRedEnvelopeLeftPanel:getHeight()
	return self.height;
end