checkRequire("Lua_FactionRedEnvelopeLeftPanel");
Lua_FactionRedEnvelopeWindow = class("Lua_FactionRedEnvelopeWindow", Lua_SecondSizeWindow);
function Lua_FactionRedEnvelopeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FactionRedEnvelopeWindow";
	self.titleText = LanUtil.getValue(124300);
end

function Lua_FactionRedEnvelopeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.redPacketsPanel = Lua_FactionRedEnvelopePanel.new(self.content);
end

function Lua_FactionRedEnvelopeWindow:dispose()
	if self.redPacketsPanel ~= nil then
		self.redPacketsPanel:dispose();
		self.redPacketsPanel = nil;
	end
	self:superCall("dispose");
end










checkRequire("Lua_FactionRedEnvelopeItem");
Lua_FactionRedEnvelopePanel = class("Lua_FactionRedEnvelopePanel", Lua_DisplayObject);
function Lua_FactionRedEnvelopePanel:ctor(p)
	self:superCall("ctor", p, "FactionRedEnvelopePanel_skin");
end

function Lua_FactionRedEnvelopePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.redEnvelopeDragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 507, 462));
	self.redEnvelopeDragList:setListCell(Lua_FactionRedEnvelopeItem, 225, 172, 3);
	self.redEnvelopeDragList:setLocation(281, 15.5, 0);

	self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(0, 5, 548, 410));
	self.dragContainer:setLocation(-265, -27, 0);
	self.redEnvelopPanel = Lua_FactionRedEnvelopeLeftPanel.new(self.content);
	self.dragContainer:addSubContainer(self.redEnvelopPanel, true);

	self.funBtn:addClickFuntion(self, self.onFunBtn);
	self.info:addClickFuntion(self, self.onInfoBtn);

	self:addLuaEvent("UPDATA_FACTION_RED_ENVELOPE_PANEL", self, self.updatePanel);
	Lua_ProxyManager.getProxy("Lua_RedEnvelopeProxy"):sGetPanelInfo({type = 2, page = 1});
end

function Lua_FactionRedEnvelopePanel:updatePanel()
	self.redEnvelopeDragList:setLuaArrayData(DataCenter.redEnvelopeData.redEnvelopeList, false);

	self.redEnvelopPanel:setData(DataCenter.redEnvelopeData);
	self.dragContainer.canDrag = self.redEnvelopPanel:getHeight() > 420;
	self.dragContainer:updateChildPos();
end

function Lua_FactionRedEnvelopePanel:onInfoBtn()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(124307));
end

function Lua_FactionRedEnvelopePanel:onFunBtn()
	local redEnvelopeConfig = DataCenter.redEnvelopeData.redEnvelopeConfig;
	local vipLimit = redEnvelopeConfig["player_send_red_packet_vip_level_limit"]["value"];
	if DataCenter.vipData.level < vipLimit then
		OperateAlert.show(LanUtil.getValue(124315));
		return;
	end
	Lua_WindowUtil.openWin("Lua_SendRedEnvelopeWindow", nil, {winType = 2, type = 2});
end